/*
 * Sample misc device driver - do nothing
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * written by usu@usupi.org
 */

#include <linux/module.h>
#include <linux/config.h>
#include <linux/kernel.h>
#include <linux/types.h>
#include <linux/sched.h>
#include <linux/fs.h>
#include <linux/miscdevice.h>


static struct file_operations usodev_fops = {
	.owner = THIS_MODULE,
};

static struct miscdevice usodev_dev = {
	.name = "uso_device",
	.minor = MISC_DYNAMIC_MINOR,
	.fops = &usodev_fops,
};

static __init int usodev_init(void)
{
	int ret;

	if((ret = misc_register(&usodev_dev)) != 0) {
		printk("%s: misc_register failed %d\n", __FUNCTION__, ret);
		return ret;
	}
	return 0;
}

static __exit void usodev_cleanup(void)
{
	misc_deregister(&usodev_dev);
}

module_init(usodev_init);
module_exit(usodev_cleanup);
MODULE_LICENSE("GPL");
